VERSION 5.00
Begin VB.MDIForm formMain 
   AutoShowChildren=   0   'False
   BackColor       =   &H8000000C&
   Caption         =   "MMC Manager"
   ClientHeight    =   6885
   ClientLeft      =   3330
   ClientTop       =   840
   ClientWidth     =   8100
   Icon            =   "Mdiform1.frx":0000
   LinkTopic       =   "MDIForm1"
   Visible         =   0   'False
   Begin VB.Timer tUpdate 
      Interval        =   10
      Left            =   0
      Top             =   0
   End
   Begin VB.PictureBox VideoSoftIndexTab1 
      Align           =   1  ' 
      BackColor       =   &H80000005&
      Height          =   612
      Left            =   0
      ScaleHeight     =   555
      ScaleWidth      =   8040
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   8100
      Begin VB.Timer Repeat 
         Interval        =   10
         Left            =   1200
         Top             =   240
      End
   End
   Begin VB.Menu idSetup 
      Caption         =   "&Setup"
      Begin VB.Menu idConfig_DPRAM 
         Caption         =   "DPRAM Address"
      End
      Begin VB.Menu idConfig_Tunning 
         Caption         =   "Tunning Param"
         Shortcut        =   {F1}
      End
      Begin VB.Menu idConfig_SwLimit 
         Caption         =   "Software Limits Config"
         Shortcut        =   {F2}
      End
      Begin VB.Menu idConfig_AxisConfig 
         Caption         =   "Axis Config"
         Shortcut        =   {F3}
      End
      Begin VB.Menu idConfig_AxisIO 
         Caption         =   "Axis I/O"
         Shortcut        =   {F4}
      End
      Begin VB.Menu idConfig_LimitSw 
         Caption         =   "Limit Switch Config"
      End
      Begin VB.Menu idConfig_User 
         Caption         =   "User I/O Config"
      End
   End
   Begin VB.Menu idView 
      Caption         =   "&View"
      Begin VB.Menu idView_Axis 
         Caption         =   "&1 Axis"
         Checked         =   -1  'True
         Index           =   1
      End
      Begin VB.Menu idView_Axis 
         Caption         =   "&2 Axis"
         Index           =   2
      End
      Begin VB.Menu idView_Axis 
         Caption         =   "&4 Axis"
         Index           =   4
      End
   End
   Begin VB.Menu idWindow 
      Caption         =   "&Window "
      WindowList      =   -1  'True
      Begin VB.Menu idWindow_Arrange 
         Caption         =   "&Cascade"
         Index           =   0
      End
      Begin VB.Menu idWindow_Arrange 
         Caption         =   "Tile &Horizontally"
         Index           =   1
      End
      Begin VB.Menu idWindow_Arrange 
         Caption         =   "Tile &Veritcally"
         Index           =   2
      End
      Begin VB.Menu idWindow_Arrange 
         Caption         =   "&Arrange Icons"
         Index           =   3
      End
   End
   Begin VB.Menu idAbout 
      Caption         =   "&About!"
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim X As Integer

Private Sub idView_Axis_Click(Index As Integer)
    idView_Axis(1).CHECKED = False
    idView_Axis(2).CHECKED = False
    idView_Axis(4).CHECKED = False
    idView_Axis(Index).CHECKED = True

    Dim i, nWindowState
    If Index = 1 Then nWindowState = 2 Else nWindowState = 0
    
    For i = 1 To UBound(formAxis)
        bLoaded(i) = i <= Index
        If bLoaded(i) Then
            formAxis(i).Hide
            formAxis(i).WindowState = nWindowState
            formAxis(i).Show
        Else
            Unload formAxis(i)
        End If
    Next i
    
    If Index > 1 Then Arrange 1 ' Tile Horizontally
End Sub

Private Sub idConfig_DPRAM_Click()
    formDpramAddr.Show
End Sub

Private Sub idAbout_Click()
    formAbout.Show
End Sub

Private Sub idConfig_User_Click()
#If PV42 Then
    If Active_Bd_Num Then formUserIo42.Show
#Else
    If Active_Bd_Num Then formUserIo.Show
#End If
End Sub

Public Sub idConfig_AxisConfig_Click()
    If Active_Bd_Num Then formAxisConfig.axis = ActiveForm.axis: formAxisConfig.Show
End Sub

Public Sub idConfig_AxisIo_Click()
    If Active_Bd_Num Then formNAxisIo.axis = ActiveForm.axis: formNAxisIo.Show
End Sub

Public Sub idConfig_LimitSw_Click()
    If Active_Bd_Num Then formLimitSw.axis = ActiveForm.axis: formLimitSw.Show
End Sub

Public Sub idConfig_SwLimit_Click()
    If Active_Bd_Num Then formSwLimit.axis = ActiveForm.axis: formSwLimit.Show
End Sub

Public Sub idConfig_Tunning_Click()
    If Active_Bd_Num Then formTunning.axis = ActiveForm.axis: formTunning.Show
End Sub

Private Sub idWindow_Arrange_Click(Index As Integer)
    Arrange Index
End Sub

Private Sub MDIForm_Load()
    
    If App.PrevInstance Then End

    Dim strRet As String
    Dim i As Integer, num As Integer
    Dim dpram_addr(0 To MAX_BD_NUM - 1) As Long
    Dim KeyName As String
    
'#If PV42 Then
    
    Dim lRtn    As Long     '-- API ȯ ڵ
    Dim hKey    As Long     '--  Ű ڵ
    Dim strAddress(0 To MAX_BD_NUM - 1) As String
    Dim sValue  As String   '-- String   ϱ
    Dim lSize   As Long     '--  String  ũ
    
  
    '-- Ʈ Ű 
    #If WINNT Then
        lRtn = RegOpenKeyEx(HKEY_LOCAL_MACHINE, MMCRegKeyNT, 0&, KEY_ALL_ACCESS, hKey)
    #Else
        lRtn = RegOpenKeyEx(HKEY_LOCAL_MACHINE, MMCRegKey98, 0&, KEY_ALL_ACCESS, hKey)
    #End If
    
  
    '--  ˻
    If lRtn <> ERROR_SUCCESS Then
        #If PV42 Then
        strAddress(0) = "d8000000"
        strAddress(1) = "d9000000"
        strAddress(2) = "da000000"
        strAddress(3) = "db000000"
        strAddress(4) = "dc000000"
        strAddress(5) = "dd000000"
        strAddress(6) = "de000000"
        strAddress(7) = "df000000"
        #Else
        strAddress(0) = "d8000000"
        strAddress(1) = "d8400000"
        strAddress(2) = "d8800000"
        strAddress(3) = "d8c00000"
        strAddress(4) = "d9000000"
        strAddress(5) = "d9400000"
        strAddress(6) = "d9800000"
        strAddress(7) = "d9c00000"
        #End If
        
        lRtn = RegCreateKeyEx(HKEY_LOCAL_MACHINE, MMCRegKey98, 0&, vbNullString, _
                        REG_OPTION_NON_VOLATILE, _
                        KEY_ALL_ACCESS, 0&, hKey, lRtn)
        
        
        For i = 0 To MAX_BD_NUM - 1
        
            sValue = strAddress(i)        '-- Ű  Ҵ
            lSize = Len(sValue)      '-- String ũ 
            
            #If WINNT Then
                KeyName = "MemoryAddress" + Format(i, "0")
            #Else
                KeyName = "DPRAM" + Format(i, "0")
            #End If
            
            '-- String  
            lRtn = RegSetValueExString(hKey, KeyName, 0&, REG_SZ, sValue, lSize)
        
        Next i
        
        
        RegCloseKey (hKey)
        MsgBox "MMC registeration complete - Restart MMC again!", 64
        End
        
        
        For i = 0 To MAX_BD_NUM - 1
'            #If PV42 Then
                #If WINNT Then
                    KeyName = "MemoryAddress" + Format(i, "0")
                    VbRegSetValue HKEY_LOCAL_MACHINE, MMCRegKeyNT, KeyName, REG_SZ, strAddress(i)
                #Else
                    KeyName = "DPRAM" + Format(i, "0")
                    VbRegSetValue HKEY_LOCAL_MACHINE, MMCRegKey98, KeyName, REG_SZ, strAddress(i)
                #End If
'            #End If
        Next i
    
    
    End If

    
    
    num = 0
    For i = 0 To MAX_BD_NUM - 1
        #If WINNT Then
            KeyName = "MemoryAddress" + Format(i, "0")
            strRet = VbRegQueryValue(HKEY_LOCAL_MACHINE, MMCRegKeyNT, KeyName)
            If val("&H" + Hex$(val(strRet))) <> 0 Then
                dpram_addr(i) = val("&H" + Hex$(val(strRet)) + "000")
                strRet = ""
                num = num + 1
            End If
        #Else
            KeyName = "DPRAM" + Format(i, "0")
            strRet = VbRegQueryValue(HKEY_LOCAL_MACHINE, MMCRegKey98, KeyName)
            If val("&H" + strRet) <> 0 Then
                dpram_addr(i) = val("&H" + strRet)
                strRet = ""
                num = num + 1
            End If
        
        #End If
        
    Next i
    
    If num = 0 Then
        MsgBox "No MMC Boards are found!", 16
        formDpramAddr.Show 1 'Modal
        MsgBox "Address setup complete - Restart MMC again!", 64
        End
    End If
    
    If mmc_initx(num, dpram_addr(0)) <> 0 Then
        MsgBox "No MMC Boards are found!", 16
        formDpramAddr.Show 1 'Modal
        MsgBox "Address setup complete - Restart MMC again!", 64
        End
    
    End If


'#Else
'
'    If mmc_init() <> 0 Then
'        MsgBox "No MMC Boards are found!", 16
'        formDpramAddr.Show 1 'Modal
'        MsgBox "Address setup complete - Restart MMC again!", 64
'        End
'
'    End If
'
'#End If

    'tUpdate.Interval = 10 'insert 98.04.22
    Active_Bd_Num = get_bd_num()
    Active_Axis_Num = get_axis_num()

Dim ff As Double, xx As Double
For i = 0 To Active_Axis_Num - 1
    xx = get_vel_limit(i, ff) 'val(tb(3))
    xx = fset_vel_limit(i, ff)
Next

    If Active_Axis_Num < 4 Then idView_Axis(4).Enabled = False
    If Active_Axis_Num < 2 Then idView_Axis(2).Enabled = False
    If Active_Axis_Num < 1 Then idView_Axis(1).Enabled = False
'    If Active_Axis_Num <= 0 Then MsgBox "MMC Board does not exist.", vbCritical
    
'===================================================

'   Load Initialization Profile...
    Dim n As Integer
    Active_Bd_Axis_Num(0) = 0
    Active_Bd_Axis_SumNum(0) = 0
    For i = 0 To Active_Bd_Num - 1
        X = mmc_axes(i, n)
        Active_Bd_Axis_SumNum(i + 1) = Active_Bd_Axis_SumNum(i) + n
        Active_Bd_Axis_Num(i + 1) = n
    Next i
    
    Dim sz$, szSec$, szKey$, szIni$

    szIni$ = App.EXEName + ".ini"
    For i = 0 To Active_Axis_Num - 1
        szSec$ = "Axis" + Format$(i)

        With Mdisp(i).ri
        szKey$ = "Delay"
        '.delay = GetPrivateProfileInt(szSec$, szKey$, 0, szIni$)
        .delay = GetPrivateProfileInt(szSec$, szKey$, 100, szIni$)

        sz$ = String$(256, 0)
        szKey$ = "Position1"
        X = GetPrivateProfileString(szSec$, ByVal szKey$, "0.0", sz$, Len(sz$), szIni$)
        .pos(0) = val(sz$)

        sz$ = String$(256, 0)
        szKey$ = "Position2"
       
        X = GetPrivateProfileString(szSec$, ByVal szKey$, "100000.0", sz$, Len(sz$), szIni$)
        .pos(1) = val(sz$)

        sz$ = String$(256, 0)
        szKey$ = "Velocity"
        X = GetPrivateProfileString(szSec$, ByVal szKey$, "100000.0", sz$, Len(sz$), szIni$)
        .vel = val(sz$)

        szKey$ = "Accel"
        .acc = GetPrivateProfileInt(szSec$, szKey$, 20, szIni$)

        szKey$ = "Deccel"
        .dcc = GetPrivateProfileInt(szSec$, szKey$, 20, szIni$)

        szKey$ = "Traj"
        .traj = GetPrivateProfileInt(szSec$, szKey$, 0, szIni$)

        .cnt = 1
        End With
        
        Mdisp(i).graphics = True
'===================================================
'        X = profile_start(i)
    Next i

    h = CreateSolidBrush(GetSysColor(COLOR_WINDOW))

    szSec$ = "Global"
    szKey$ = "Interval"

    tUpdate.Interval = GetPrivateProfileInt(szSec$, szKey$, 10, szIni$)
    tUpdate.Enabled = Active_Bd_Num > 0

    If Active_Axis_Num Then idView_Axis_Click (1)
    
    'ErrorHandlerMain:   '  ó ƾԴϴ.
    '    MsgBox Err.Number
    '    MsgBox Err.Description
    '
    '    Select Case Err.Number      '  ȣ մϴ.
    '        Case 53
    '
    '            formDpramAddr42.Show vbModal
    '            MsgBox "Address Setup complete - Restart MMC Maneger!", vbInformation
    '            End
    '
    '            If (MsgBox("ȭ ã  ϴ.", vbOKCancel) = vbOK) Then
    '                fileDialog.ShowOpen
    '                If fileDialog.FileTitle <> "" Then
    '                    FileName = fileDialog.FileTitle
    '                Else
    '                    End
    '                End If
    '            Else
    '                MsgBox ("Cancel ư ̽ϴ")
    '                End
    '            End If
    '        Case 55                  ' " ̹  ֽϴ" Դϴ.
    '            Close #1            '   ݽϴ.
    '        Case 62
    '            MsgBox ("MMCBD42.DATȭ Ͻð ٽ α׷ ⵿ϼ")
    '        Case Else                ' ⼭ ٸ Ȳ ٷϴ.
    '
    '    End Select
    '    Resume   '   ٰ  ٿ
    '            '  簳մϴ.

End Sub

Private Sub MDIForm_Unload(CANCEL As Integer)
    ' Save Initialization Profile...

    ' Do clean up...
    Dim i As Integer
    For i = 0 To Active_Axis_Num
'===================================================
        X = set_amp_enable(i, 0)

    Next i

    h = DeleteObject(h)
    X = save_boot_frame
   
    End

End Sub


Private Sub tUpdate_Timer()
    Dim i
    For i = 1 To UBound(formAxis)
        If bLoaded(i) Then
            formAxis(i).tUpdate_Timer
        End If
    Next
End Sub


Public Sub Repeat_Timer()
    Dim i As Integer
    Dim currentTime As Double
    Dim tempCommand As Double
    
    For i = 0 To (MAX_BD_NUM * BD_AXIS_NUM)
    
        If (repeat_data(i).Flag_repeat = True) Then
            
            If (get_mmc_error() Or (axis_done(i) = 0) Or (axis_source(i) And ST_AMP_POWER_ONOFF) Or axis_state(i)) Then
                  
                  
                  
            Else
                If (repeat_data(i).Flag_firstEnd_repeat = False) Then
                    repeat_data(i).End_repeatTime = GetTickCount()
                    repeat_data(i).Flag_firstEnd_repeat = True
                Else
                    currentTime = GetTickCount()
                    If (currentTime > repeat_data(i).delay + repeat_data(i).End_repeatTime) Then
                        repeat_data(i).Flag_firstEnd_repeat = False
                        'go
                        Call get_command(i, tempCommand)
                        If Not (tempCommand = repeat_data(i).pos1) Then
                            If repeat_data(i).trajectory = 0 Then
                                X = start_move(i, repeat_data(i).pos1, repeat_data(i).vel, repeat_data(i).acc)
                            Else
                                X = start_s_move(i, repeat_data(i).pos1, repeat_data(i).vel, repeat_data(i).acc)
                            End If
                        Else
                            If repeat_data(i).trajectory = 0 Then
                                X = start_move(i, repeat_data(i).pos2, repeat_data(i).vel, repeat_data(i).acc)
                            Else
                                X = start_s_move(i, repeat_data(i).pos2, repeat_data(i).vel, repeat_data(i).acc)
                            End If
                        End If

                        formAxis((i \ BD_AXIS_NUM) + 1).Text1.Text = X

                    End If
                End If
            End If
        
        End If
    Next i
End Sub


